"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validate = exports.entries = exports.map = exports.get = exports.pointer = exports.value = exports.nil = undefined;

var _bluebird = require("bluebird");

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _jsonStableStringify = require("json-stable-stringify");

var _jsonStableStringify2 = _interopRequireDefault(_jsonStableStringify);

var _textEncoding = require("text-encoding");

var _jsonPointer = require("@hyperjump/json-pointer");

var JsonPointer = _interopRequireWildcard(_jsonPointer);

var _jsonReference = require("@hyperjump/json-reference");

var JsonReference = _interopRequireWildcard(_jsonReference);

var _validationResult = require("./validation-result");

var ValidationResult = _interopRequireWildcard(_validationResult);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nil = exports.nil = JsonReference.nil;
var value = exports.value = JsonReference.value;
var pointer = exports.pointer = JsonReference.pointer;
var get = exports.get = JsonReference.get;
var map = exports.map = JsonReference.map;
var entries = exports.entries = JsonReference.entries;

var validate = exports.validate = function () {
  var _ref = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee(doc) {
    var metaValidator, result;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _metaValidate(doc, {});

          case 2:
            metaValidator = _context.sent;
            result = metaValidator(value(doc));

            if (ValidationResult.isValid(result)) {
              _context.next = 6;
              break;
            }

            throw result;

          case 6:
            _context.next = 8;
            return _validate(doc, {});

          case 8:
            return _context.abrupt("return", _context.sent);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function validate(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _validate = function () {
  var _ref2 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(doc, memo) {
    var $meta, meta, validatorList;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (memo[doc.url]) {
              _context3.next = 10;
              break;
            }

            memo[doc.url] = function (_value) {
              return false;
            };

            _context3.next = 4;
            return get("#/$meta", doc);

          case 4:
            $meta = _context3.sent;
            meta = value($meta) || {};
            _context3.next = 8;
            return entries(doc).filter(function (_ref3) {
              var _ref4 = _slicedToArray(_ref3, 2),
                  keyword = _ref4[0],
                  _ = _ref4[1];

              return keyword !== "$meta";
            }).map(function () {
              var _ref5 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref6) {
                var _ref7 = _slicedToArray(_ref6, 2),
                    keyword = _ref7[0],
                    keywordDoc = _ref7[1];

                var ptr, validator;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        ptr = pointer(keywordDoc);

                        if (keyword in meta) {
                          _context2.next = 3;
                          break;
                        }

                        throw Error("Encountered undeclared keyword '" + keyword + "' at '" + ptr + "'");

                      case 3:
                        _context2.next = 5;
                        return validators[meta[keyword]](keywordDoc, memo);

                      case 5:
                        validator = _context2.sent;
                        return _context2.abrupt("return", function (value) {
                          return [ptr, validator(value)];
                        });

                      case 7:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, undefined);
              }));

              return function (_x4) {
                return _ref5.apply(this, arguments);
              };
            }());

          case 8:
            validatorList = _context3.sent;


            memo[doc.url] = function (value) {
              return validatorList.map(function (validator) {
                return validator(value);
              });
            };

          case 10:
            return _context3.abrupt("return", function (value) {
              return memo[doc.url](value);
            });

          case 11:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function _validate(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();

var metaValidators = {};
var _metaValidate = function () {
  var _ref8 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(doc, memo) {
    var $meta, meta;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return get("#/$meta", doc);

          case 2:
            $meta = _context5.sent;
            meta = value($meta) || {};
            _context5.next = 6;
            return Promise.all(Object.entries(meta).filter(function (_ref9) {
              var _ref10 = _slicedToArray(_ref9, 2),
                  keyword = _ref10[0],
                  keywordUrl = _ref10[1];

              return keyword[0] !== "$" && !(keywordUrl in metaValidators);
            }).map(function () {
              var _ref11 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref12) {
                var _ref13 = _slicedToArray(_ref12, 2),
                    keyword = _ref13[0],
                    _ = _ref13[1];

                var keywordUrl, metaDoc;
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        keywordUrl = meta[keyword];
                        _context4.next = 3;
                        return get(keywordUrl);

                      case 3:
                        metaDoc = _context4.sent;

                        metaValidators[keywordUrl] = false;
                        _context4.next = 7;
                        return _validate(metaDoc, memo);

                      case 7:
                        metaValidators[keywordUrl] = _context4.sent;

                      case 8:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, undefined);
              }));

              return function (_x7) {
                return _ref11.apply(this, arguments);
              };
            }()));

          case 6:
            return _context5.abrupt("return", function (value) {
              return Object.keys(value).filter(function (keyword) {
                return keyword in meta;
              }).map(function (keyword) {
                var keywordUrl = meta[keyword];
                var result = metaValidators[keywordUrl](value[keyword]);
                return [JsonPointer.cons(keyword, JsonPointer.nil), ValidationResult.isValid(result)];
              });
            });

          case 7:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function _metaValidate(_x5, _x6) {
    return _ref8.apply(this, arguments);
  };
}();

var isObject = function isObject(value) {
  return (typeof value === "undefined" ? "undefined" : _typeof(value)) === "object" && !Array.isArray(value) && value !== null;
};

var isType = {
  "null": function _null(value) {
    return value === null;
  },
  "boolean": function boolean(value) {
    return typeof value === "boolean";
  },
  "object": isObject,
  "array": function array(value) {
    return Array.isArray(value);
  },
  "number": function number(value) {
    return typeof value === "number";
  },
  "string": function string(value) {
    return typeof value === "string";
  }
};

var numberEqual = function numberEqual(a, b) {
  return Math.abs(a - b) < Number.EPSILON;
};

var multipleOf = function multipleOf(_multipleOf, value) {
  var remainder = value % _multipleOf;
  return numberEqual(0, remainder) || numberEqual(_multipleOf, remainder);
};

var jsonStringLength = function jsonStringLength(string) {
  return new _textEncoding.TextEncoder("utf-8").encode(string).length;
};

var validators = {};

validators["http://validation.hyperjump.io/common/const"] = function () {
  var _ref14 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(doc) {
    var constValue, expected;
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            constValue = value(doc);
            expected = (0, _jsonStableStringify2.default)(constValue);
            return _context6.abrupt("return", function (value) {
              return (0, _jsonStableStringify2.default)(value) === expected;
            });

          case 3:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, undefined);
  }));

  return function (_x8) {
    return _ref14.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/type"] = function () {
  var _ref15 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(doc) {
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            return _context7.abrupt("return", isType[value(doc)]);

          case 1:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7, undefined);
  }));

  return function (_x9) {
    return _ref15.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/multipleOf"] = function () {
  var _ref16 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(doc) {
    var multipleOfValue;
    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            multipleOfValue = value(doc);
            return _context8.abrupt("return", function (value) {
              return typeof value !== "number" || multipleOf(multipleOfValue, value);
            });

          case 2:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8, undefined);
  }));

  return function (_x10) {
    return _ref16.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/maximum"] = function () {
  var _ref17 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(doc) {
    var maximum;
    return regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            maximum = value(doc);
            return _context9.abrupt("return", function (value) {
              return typeof value !== "number" || value <= maximum;
            });

          case 2:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9, undefined);
  }));

  return function (_x11) {
    return _ref17.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/exclusiveMaximum"] = function () {
  var _ref18 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(doc) {
    var exclusiveMaximum;
    return regeneratorRuntime.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            exclusiveMaximum = value(doc);
            return _context10.abrupt("return", function (value) {
              return typeof value !== "number" || value < exclusiveMaximum;
            });

          case 2:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10, undefined);
  }));

  return function (_x12) {
    return _ref18.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/minimum"] = function () {
  var _ref19 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(doc) {
    var minimum;
    return regeneratorRuntime.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            minimum = value(doc);
            return _context11.abrupt("return", function (value) {
              return typeof value !== "number" || value >= minimum;
            });

          case 2:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11, undefined);
  }));

  return function (_x13) {
    return _ref19.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/exclusiveMinimum"] = function () {
  var _ref20 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(doc) {
    var exclusiveMinimum;
    return regeneratorRuntime.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            exclusiveMinimum = value(doc);
            return _context12.abrupt("return", function (value) {
              return typeof value !== "number" || value > exclusiveMinimum;
            });

          case 2:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12, undefined);
  }));

  return function (_x14) {
    return _ref20.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/maxLength"] = function () {
  var _ref21 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(doc) {
    var maxLength;
    return regeneratorRuntime.wrap(function _callee13$(_context13) {
      while (1) {
        switch (_context13.prev = _context13.next) {
          case 0:
            maxLength = value(doc);
            return _context13.abrupt("return", function (value) {
              return typeof value !== "string" || jsonStringLength(value) <= maxLength;
            });

          case 2:
          case "end":
            return _context13.stop();
        }
      }
    }, _callee13, undefined);
  }));

  return function (_x15) {
    return _ref21.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/minLength"] = function () {
  var _ref22 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(doc) {
    var minLength;
    return regeneratorRuntime.wrap(function _callee14$(_context14) {
      while (1) {
        switch (_context14.prev = _context14.next) {
          case 0:
            minLength = value(doc);
            return _context14.abrupt("return", function (value) {
              return typeof value !== "string" || jsonStringLength(value) >= minLength;
            });

          case 2:
          case "end":
            return _context14.stop();
        }
      }
    }, _callee14, undefined);
  }));

  return function (_x16) {
    return _ref22.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/pattern"] = function () {
  var _ref23 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee15(doc) {
    var pattern;
    return regeneratorRuntime.wrap(function _callee15$(_context15) {
      while (1) {
        switch (_context15.prev = _context15.next) {
          case 0:
            pattern = new RegExp(value(doc));
            return _context15.abrupt("return", function (value) {
              return typeof value !== "string" || pattern.test(value);
            });

          case 2:
          case "end":
            return _context15.stop();
        }
      }
    }, _callee15, undefined);
  }));

  return function (_x17) {
    return _ref23.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/items"] = function () {
  var _ref24 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee16(doc, memo) {
    var validateItem;
    return regeneratorRuntime.wrap(function _callee16$(_context16) {
      while (1) {
        switch (_context16.prev = _context16.next) {
          case 0:
            _context16.next = 2;
            return _validate(doc, memo);

          case 2:
            validateItem = _context16.sent;
            return _context16.abrupt("return", function (value) {
              return !Array.isArray(value) || value.every(function (item) {
                return ValidationResult.isValid(validateItem(item));
              });
            });

          case 4:
          case "end":
            return _context16.stop();
        }
      }
    }, _callee16, undefined);
  }));

  return function (_x18, _x19) {
    return _ref24.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/tupleItems"] = function () {
  var _ref25 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee17(doc, memo) {
    var tupleItems;
    return regeneratorRuntime.wrap(function _callee17$(_context17) {
      while (1) {
        switch (_context17.prev = _context17.next) {
          case 0:
            _context17.next = 2;
            return map(function (itemSchema) {
              return _validate(itemSchema, memo);
            }, doc);

          case 2:
            tupleItems = _context17.sent;
            return _context17.abrupt("return", function (value) {
              return !Array.isArray(value) || value.every(function (item, ndx) {
                return !(ndx in tupleItems) || ValidationResult.isValid(tupleItems[ndx](item));
              });
            });

          case 4:
          case "end":
            return _context17.stop();
        }
      }
    }, _callee17, undefined);
  }));

  return function (_x20, _x21) {
    return _ref25.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/maxItems"] = function () {
  var _ref26 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee18(doc) {
    var maxItems;
    return regeneratorRuntime.wrap(function _callee18$(_context18) {
      while (1) {
        switch (_context18.prev = _context18.next) {
          case 0:
            maxItems = value(doc);
            return _context18.abrupt("return", function (value) {
              return !Array.isArray(value) || value.length <= maxItems;
            });

          case 2:
          case "end":
            return _context18.stop();
        }
      }
    }, _callee18, undefined);
  }));

  return function (_x22) {
    return _ref26.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/minItems"] = function () {
  var _ref27 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee19(doc) {
    var minItems;
    return regeneratorRuntime.wrap(function _callee19$(_context19) {
      while (1) {
        switch (_context19.prev = _context19.next) {
          case 0:
            minItems = value(doc);
            return _context19.abrupt("return", function (value) {
              return !Array.isArray(value) || value.length >= minItems;
            });

          case 2:
          case "end":
            return _context19.stop();
        }
      }
    }, _callee19, undefined);
  }));

  return function (_x23) {
    return _ref27.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/uniqueItems"] = function () {
  var _ref28 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(doc) {
    var uniqueItems;
    return regeneratorRuntime.wrap(function _callee20$(_context20) {
      while (1) {
        switch (_context20.prev = _context20.next) {
          case 0:
            uniqueItems = value(doc);
            return _context20.abrupt("return", function (value) {
              if (!Array.isArray(value) || uniqueItems === false) {
                return true;
              }

              var normalizedItems = value.map(_jsonStableStringify2.default);
              return new Set(normalizedItems).size === normalizedItems.length;
            });

          case 2:
          case "end":
            return _context20.stop();
        }
      }
    }, _callee20, undefined);
  }));

  return function (_x24) {
    return _ref28.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/properties"] = function () {
  var _ref29 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee22(doc, memo) {
    var propertyValidators;
    return regeneratorRuntime.wrap(function _callee22$(_context22) {
      while (1) {
        switch (_context22.prev = _context22.next) {
          case 0:
            _context22.t0 = Map;
            _context22.next = 3;
            return entries(doc).map(function () {
              var _ref30 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee21(_ref31) {
                var _ref32 = _slicedToArray(_ref31, 2),
                    propertyName = _ref32[0],
                    propertySchema = _ref32[1];

                return regeneratorRuntime.wrap(function _callee21$(_context21) {
                  while (1) {
                    switch (_context21.prev = _context21.next) {
                      case 0:
                        _context21.t0 = propertyName;
                        _context21.next = 3;
                        return _validate(propertySchema, memo);

                      case 3:
                        _context21.t1 = _context21.sent;
                        return _context21.abrupt("return", [_context21.t0, _context21.t1]);

                      case 5:
                      case "end":
                        return _context21.stop();
                    }
                  }
                }, _callee21, undefined);
              }));

              return function (_x27) {
                return _ref30.apply(this, arguments);
              };
            }());

          case 3:
            _context22.t1 = _context22.sent;
            propertyValidators = new _context22.t0(_context22.t1);
            return _context22.abrupt("return", function (value) {
              return !isObject(value) || Object.keys(value).filter(function (propertyName) {
                return propertyValidators.has(propertyName);
              }).every(function (propertyName) {
                var validator = propertyValidators.get(propertyName);
                var result = validator(value[propertyName]);
                return ValidationResult.isValid(result);
              });
            });

          case 6:
          case "end":
            return _context22.stop();
        }
      }
    }, _callee22, undefined);
  }));

  return function (_x25, _x26) {
    return _ref29.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/patternProperties"] = function () {
  var _ref33 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee24(doc, memo) {
    var validators;
    return regeneratorRuntime.wrap(function _callee24$(_context24) {
      while (1) {
        switch (_context24.prev = _context24.next) {
          case 0:
            _context24.next = 2;
            return entries(doc).map(function () {
              var _ref34 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee23(_ref35) {
                var _ref36 = _slicedToArray(_ref35, 2),
                    propertyPattern = _ref36[0],
                    propertySchema = _ref36[1];

                return regeneratorRuntime.wrap(function _callee23$(_context23) {
                  while (1) {
                    switch (_context23.prev = _context23.next) {
                      case 0:
                        _context23.t0 = new RegExp(propertyPattern);
                        _context23.next = 3;
                        return _validate(propertySchema, memo);

                      case 3:
                        _context23.t1 = _context23.sent;
                        return _context23.abrupt("return", [_context23.t0, _context23.t1]);

                      case 5:
                      case "end":
                        return _context23.stop();
                    }
                  }
                }, _callee23, undefined);
              }));

              return function (_x30) {
                return _ref34.apply(this, arguments);
              };
            }());

          case 2:
            validators = _context24.sent;
            return _context24.abrupt("return", function (value) {
              return !isObject(value) || validators.every(function (_ref37) {
                var _ref38 = _slicedToArray(_ref37, 2),
                    pattern = _ref38[0],
                    validateProperty = _ref38[1];

                return Object.keys(value).filter(function (propertyName) {
                  return pattern.test(propertyName);
                }).every(function (propertyName) {
                  return ValidationResult.isValid(validateProperty(value[propertyName]));
                });
              });
            });

          case 4:
          case "end":
            return _context24.stop();
        }
      }
    }, _callee24, undefined);
  }));

  return function (_x28, _x29) {
    return _ref33.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/propertyNames"] = function () {
  var _ref39 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee25(doc, memo) {
    var validateName;
    return regeneratorRuntime.wrap(function _callee25$(_context25) {
      while (1) {
        switch (_context25.prev = _context25.next) {
          case 0:
            _context25.next = 2;
            return _validate(doc, memo);

          case 2:
            validateName = _context25.sent;
            return _context25.abrupt("return", function (value) {
              return !isObject(value) || Object.keys(value).every(function (name) {
                return ValidationResult.isValid(validateName(name));
              });
            });

          case 4:
          case "end":
            return _context25.stop();
        }
      }
    }, _callee25, undefined);
  }));

  return function (_x31, _x32) {
    return _ref39.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/maxProperties"] = function () {
  var _ref40 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee26(doc) {
    var maxProperties;
    return regeneratorRuntime.wrap(function _callee26$(_context26) {
      while (1) {
        switch (_context26.prev = _context26.next) {
          case 0:
            maxProperties = value(doc);
            return _context26.abrupt("return", function (value) {
              return !isObject(value) || Object.keys(value).length <= maxProperties;
            });

          case 2:
          case "end":
            return _context26.stop();
        }
      }
    }, _callee26, undefined);
  }));

  return function (_x33) {
    return _ref40.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/minProperties"] = function () {
  var _ref41 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee27(doc) {
    var minProperties;
    return regeneratorRuntime.wrap(function _callee27$(_context27) {
      while (1) {
        switch (_context27.prev = _context27.next) {
          case 0:
            minProperties = value(doc);
            return _context27.abrupt("return", function (value) {
              return !isObject(value) || Object.keys(value).length >= minProperties;
            });

          case 2:
          case "end":
            return _context27.stop();
        }
      }
    }, _callee27, undefined);
  }));

  return function (_x34) {
    return _ref41.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/required"] = function () {
  var _ref42 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee28(doc) {
    var required;
    return regeneratorRuntime.wrap(function _callee28$(_context28) {
      while (1) {
        switch (_context28.prev = _context28.next) {
          case 0:
            required = value(doc);
            return _context28.abrupt("return", function (value) {
              return !isObject(value) || required.every(function (propertyName) {
                return propertyName in value;
              });
            });

          case 2:
          case "end":
            return _context28.stop();
        }
      }
    }, _callee28, undefined);
  }));

  return function (_x35) {
    return _ref42.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/allOf"] = function () {
  var _ref43 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee29(doc, memo) {
    var allOf;
    return regeneratorRuntime.wrap(function _callee29$(_context29) {
      while (1) {
        switch (_context29.prev = _context29.next) {
          case 0:
            _context29.next = 2;
            return map(function (subSchema) {
              return _validate(subSchema, memo);
            }, doc);

          case 2:
            allOf = _context29.sent;
            return _context29.abrupt("return", function (value) {
              return allOf.every(function (validateSchema) {
                return ValidationResult.isValid(validateSchema(value));
              });
            });

          case 4:
          case "end":
            return _context29.stop();
        }
      }
    }, _callee29, undefined);
  }));

  return function (_x36, _x37) {
    return _ref43.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/anyOf"] = function () {
  var _ref44 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee30(doc, memo) {
    var anyOf;
    return regeneratorRuntime.wrap(function _callee30$(_context30) {
      while (1) {
        switch (_context30.prev = _context30.next) {
          case 0:
            _context30.next = 2;
            return map(function (subSchema) {
              return _validate(subSchema, memo);
            }, doc);

          case 2:
            anyOf = _context30.sent;
            return _context30.abrupt("return", function (value) {
              return anyOf.some(function (validateSchema) {
                return ValidationResult.isValid(validateSchema(value));
              });
            });

          case 4:
          case "end":
            return _context30.stop();
        }
      }
    }, _callee30, undefined);
  }));

  return function (_x38, _x39) {
    return _ref44.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/oneOf"] = function () {
  var _ref45 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee31(doc, memo) {
    var oneOf;
    return regeneratorRuntime.wrap(function _callee31$(_context31) {
      while (1) {
        switch (_context31.prev = _context31.next) {
          case 0:
            _context31.next = 2;
            return map(function (subSchema) {
              return _validate(subSchema, memo);
            }, doc);

          case 2:
            oneOf = _context31.sent;
            return _context31.abrupt("return", function (value) {
              return oneOf.reduce(function (acc, validateSchema) {
                var isValid = ValidationResult.isValid(validateSchema(value));
                return acc ? !isValid : isValid;
              }, false);
            });

          case 4:
          case "end":
            return _context31.stop();
        }
      }
    }, _callee31, undefined);
  }));

  return function (_x40, _x41) {
    return _ref45.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/not"] = function () {
  var _ref46 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee32(doc, memo) {
    var validateSchema;
    return regeneratorRuntime.wrap(function _callee32$(_context32) {
      while (1) {
        switch (_context32.prev = _context32.next) {
          case 0:
            _context32.next = 2;
            return _validate(doc, memo);

          case 2:
            validateSchema = _context32.sent;
            return _context32.abrupt("return", function (value) {
              return !ValidationResult.isValid(validateSchema(value));
            });

          case 4:
          case "end":
            return _context32.stop();
        }
      }
    }, _callee32, undefined);
  }));

  return function (_x42, _x43) {
    return _ref46.apply(this, arguments);
  };
}();

validators["http://validation.hyperjump.io/common/definitions"] = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee33() {
  return regeneratorRuntime.wrap(function _callee33$(_context33) {
    while (1) {
      switch (_context33.prev = _context33.next) {
        case 0:
          return _context33.abrupt("return", function () {
            return true;
          });

        case 1:
        case "end":
          return _context33.stop();
      }
    }
  }, _callee33, undefined);
}));

validators["http://validation.hyperjump.io/common/validation"] = function () {
  var _ref48 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee34(doc, memo) {
    var validator, isSchema;
    return regeneratorRuntime.wrap(function _callee34$(_context34) {
      while (1) {
        switch (_context34.prev = _context34.next) {
          case 0:
            _context34.next = 2;
            return _metaValidate(doc, memo);

          case 2:
            validator = _context34.sent;
            isSchema = value(doc);
            return _context34.abrupt("return", function (value) {
              if (!isObject(value) || isSchema === false) {
                return true;
              }

              var result = validator(value);
              return ValidationResult.isValid(result);
            });

          case 5:
          case "end":
            return _context34.stop();
        }
      }
    }, _callee34, undefined);
  }));

  return function (_x44, _x45) {
    return _ref48.apply(this, arguments);
  };
}();